<?php
/*
Fast Edit 1.0 - An "edit in place" tool with extended CMS capabilities (C) 2010 Beverley Hooton
(author website - http://fast-edit.co.uk/)

    Fast Edit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// name of website
$website_title = 'My Website';

// website domain with trailing slash
$siteurl = 'http://www.mywebsite.com/';

// website root path with trailing slash
// $rooturl = '/home/www/mywebsite.com/'; - below setting should work automatically but if not, set root path manually
$rooturl = dirname(realpath(dirname(__FILE__))).'/';

// usernames and passwords - paired in same order 
$usernames = array(
'user1', 		// user 1
'user2',		// user 2 
'user3'			// user 3 <--- no comma after last username
);

$passwords = array(
'pass1', 		// pass 1
'pass2', 		// pass 2
'pass3'			// pass 3 <--- no comma after last password
);

// assign pages to users - these users can only edit assigned pages, with basic page manager
// array per user - $username, followed by pages to edit - users not listed can edit all pages
$assignments = array(
	array('user2','features.php','menu_alias.php','protected_page.php','index.php'),
	array('user3','features.php','menu_alias.php') // <--- no comma after last page or array
	);

// time difference corrector - hours offset from GMT (+/-) 
$gmt_offset = '+1';

// custom separator - dash/hyphen or underscore in URL/page names
$separator = '-'; // '-' or '_' ('-' is better for SEO)

// sort menu items alphabetically (A-Z) or manually
// 0; = manually, 1; = A-Z   -   default is manually
$menu_sort = 0;

// allow usage of template manager (user can edit "fast_edit/editable_site_styles.css")
// 0; = no, 1; = yes   -   default is yes
$use_template_manager = 1;

// allow usage of metadata manager
// 0; = no, 1; = yes   -   default is yes - not effective if page manager is set to basic mode (below)
$use_metadata_manager = 1;

// use basic or advanced page manager (basic does not include menu order, metadata, menu status toggle, menu alias, create page or delete page)
// 0; = basic, 1; = advanced   -   default is advanced
$adv_page_manager = 1;

// set maximum page count - limit the end-user to a maximum number of pages they can have on their website
// 0; = unlimited   -   not effective if page manager is set to basic mode (above)
$page_count = 10;

// .php pages to protect from delete action - optional setting for custom pages - included in $page_count
// $page_protect = array('special_page.php','another_special_page.php','protected_page.php');
$page_protect = array('protected_page.php', 'multi-regions.php');

// .php pages to exclude from main menu, page manager and sitemap.xml - optional setting for custom pages - excluded from $page_count
// $page_exclude = array('my_page.php','another_page.php','example_page.php');
$page_exclude = array();

// pager increments for pages listed in page manager
$pager_increments = array(5, 10, 15, 20, 25); // an 'All pages' limit is automatically set at 1000
$pager_default_limit = 10;

// how often your website is updated - indicator for search engine spiders (sitemap.xml includes protected pages and pages hidden from menu)
// 'none', 'always', 'hourly', 'daily', 'weekly', 'monthly', 'yearly'   -   default is 'monthly' 
$changefreq = 'monthly'; // ('weekly'/'monthly' suits most websites)

// use gzip compression in php for speed boost - ob_gzhandler requires zlib extension - http://php.net/ob-gzhandler 
// can't be used with zlib.output_compression so leave this off if you're not sure, or if you get errors with it on
// 0; = no, 1; = yes   -   default is no
$use_ob_gzhandler = 0;

// how to encode text in keywords, description and menu alias fields - http://php.net/manual/en/function.htmlentities.php
// 'UTF-8'; or 'ISO-8859-1'; are most common for English and Western European languages  -   default is 'UTF-8'
$charset = 'UTF-8';

// settings for file manager 
// see "fast_edit/tinymce/tinymce/jscripts/tiny_mce/plugins/tinybrowser/config_tinybrowser.php"
// - File upload paths
// - File link paths
// - Maximum disk space quota
// - File upload size limit in bytes (0 is unlimited) (512000 = 500KB) (1048576 = 1MB) (2097152 = 2MB) (1073741824 = 1GB)
// - Permitted file extensions
// - Assign Permissions for Upload, Edit, Delete & Folder actions (true or false)





#### NO NEED TO EDIT PAST THIS LINE ####

// website root path to editable content with trailing slash
$root = $rooturl.'fast_edit/_content/'; 

// website root path to backup content with trailing slash
$rootbackup = $rooturl.'fast_edit/_backup/'; 

// website root path to menu status files with trailing slash
$menu_status = $rooturl.'fast_edit/_menu_status/';

// website root path to menu alias files with trailing slash
$menu_alias = $rooturl.'fast_edit/_menu_alias/';

// website root path to meta keywords files with trailing slash
$keywords = $rooturl.'fast_edit/_keywords/';

// website root path to meta description files with trailing slash
$descriptions = $rooturl.'fast_edit/_descriptions/';

// website root path to sitemap.xml file
$xml = $rooturl.'sitemap.xml';

// dynamic auto title script for <title> tag
$title = basename(substr($_SERVER['PHP_SELF'], 0,strrpos($_SERVER['PHP_SELF'],'.'))); // get page name and strip path and extention
$title1 = str_replace(array('-and-','_and_'), ' & ', $title); // convert 'and' to &
$title2 = str_replace(array('-','_'), ' ', strtolower($title1)); // convert name to lowercase and replace hyphen/underscores with space
						
if ($title2 == 'index') { 
	$dynamic_title = 'Home'; // index to Home
	} else { 
	$dynamic_title = ucwords($title2); // capitalize first letter
	}

$alias = @file_get_contents($menu_alias.$title.'.txt');
if ( $alias != '' ) {
	$dynamic_title = $alias;
	} else {
	$dynamic_title = $dynamic_title;
	}

//recognise editable content .txt file from base .php file
$basepage = basename(substr($_SERVER['PHP_SELF'], 0,strrpos($_SERVER['PHP_SELF'],'.')));
$contentpage = $root.$basepage.".txt"; 

// dynamic auto title script for preview pages
if (isset($_GET['previewfile'])) {
  	$previewfile = $_GET['previewfile'];
  	} else {
  	$previewfile = ''; 
  	}

// get and display custom keywords if file exists else display default
$keywords_file = $keywords.$basepage.".txt";
$keys = @file_get_contents($keywords_file);
if ($keys != '') { 	
	$meta_keys = $keywords_file; 
	} else { 
	$meta_keys = $keywords."_default_keywords.txt"; 
	} 

// get and display custom descriptions if file exists else display default
$descriptions_file = $descriptions.$basepage.".txt";
$descs = @file_get_contents($descriptions_file);
if ($descs != '') { 	
	$meta_descs = $descriptions_file; 
	} else { 
	$meta_descs = $descriptions."_default_descriptions.txt"; 
	} 

$basepage_preview = substr($previewfile, 0, strpos($previewfile, '.'));
$basepage_preview = str_replace(array('-and-','_and_'), ' & ', $basepage_preview); // convert 'and' to &
$title_preview = str_replace(array('-','_'), ' ', strtolower($basepage_preview)); // convert name to lowercase and replace hyphen/underscores with space
if ( $title_preview == 'index' ) {
	$dynamic_title_preview = 'Home'; // 'index' to 'Home'
	} else {
	$dynamic_title_preview = ucwords($title_preview); // capitalize first letter 
	}

$ass_user = 0; // user has no assigned pages
$ass_pages = array();
foreach ($assignments as $assignment) {
	if (isset($_SESSION['username']) && in_array($_SESSION['username'], $assignment)) { // if current user has assigned pages
		$ass_user = $_SESSION['username']; 
		$adv_page_manager = 0; // switch to basic page manager    
		foreach ($assignment as $ass_page) {
			$ass_pages[] = $ass_page;
    			}
		}
	}
array_shift($ass_pages);

?>