<?php 
/*
Fast Edit 1.0 - An "edit in place" tool with extended CMS capabilities (C) 2010 Beverley Hooton
(author website - http://fast-edit.co.uk/)

    Fast Edit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


function ByteSize($bytes) { // http://www.phpfront.com/php/Convert-Bytes-to-corresponding-size/
	$size = $bytes / 1024; 
	if($size < 1024) { 
		$size = number_format($size, 0); // format to 0 decimal places
		$size .= 'KB'; 
		} else { 
		if($size / 1024 < 1024) { 
			$size = number_format($size / 1024, 0); // format to 0 decimal places
			$size .= 'MB'; 
			} else if ($size / 1024 / 1024 < 1024) { 
			$size = number_format($size / 1024 / 1024, 2); 
			$size .= 'GB'; 
			}  
		} 
	return $size; 
	} 
// Returns '19.28mb' 
//print ByteSize('20211982'); 


function GetFolderSize($d ="." ) { // http://www.weberdev.com/get_example-4561.html (recursive total)
    	$h = @opendir($d); 
    	if($h==0)return 0; 
    	while ($f=readdir($h)) { 
        	if ( $f!= "..") { 
            		$sf+=filesize($nd=$d."/".$f); 
            		if($f!="."&&is_dir($nd)) { 
                		$sf+=GetFolderSize ($nd); 
            			} 
        		} 
    		} 
    		closedir($h); 
    		return $sf ; 
	}


function filecount($FolderPath) { // http://www.dreamincode.net/code/snippet1906.htm    
	$filescount = 0;
	$dir = opendir($FolderPath);
	while (($file = readdir($dir)) !== false) { 
        	if ($file[0] == '.'){ continue; }		
        	if (is_dir($FolderPath.$file)) { // if '.' it is a sub folder and call the function recursively    
            		$filescount += filecount($FolderPath.$file.DIRECTORY_SEPARATOR); // Call the function if it is a folder type			
        		} else {
            		$filescount++;
        		}
    		}    
		closedir($dir);
		return $filescount;
	}


function do_reg($text, $regex) { // http://forums.phpfreaks.com/topic/151507-solved-extract-url-from-string/
	preg_match_all($regex, $text, $result, PREG_PATTERN_ORDER);
	return $result[0];
	}
$regex = '\b(https?|ftp|file)://[-A-Z0-9+&@#/%?=~_|!:,.;]*[-A-Z0-9+&@#/%=~_|]';
$regex = '$'.$regex.'$i';


function SiteMap($rooturl, $root, $siteurl, $xml, $changefreq, $page_exclude, $gmt_offset) {
	$fpx = fopen($xml,'w+');
	$startdata = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">
<url> 
  <loc>$siteurl</loc>
  <changefreq>$changefreq</changefreq>
</url>\n";
	fwrite($fpx,$startdata);

	$dh = opendir($rooturl);
	$file_array = array(); // (re)set this as empty
	while (false !== ($file = readdir($dh)) ) {
		if (strpos($file, '.php', 1)) { // only include files with .php extension	
			$button_link_check = strpos(file_get_contents($rooturl.$file), '<?php header(\'Location:');
			if ($button_link_check !== false) {
				$hidefile = $file; 
				} else {
				$hidefile = ''; 
				}
			if ( $file!='.' && $file!='..' && $file!='page_preview.php' && $file!=$hidefile) {
				if (!in_array($file, $page_exclude)) { // exclude pages from $page_exclude() array
 					$file_array[] = $rooturl.$file;  
					}
				}
			}
		}
	foreach ($file_array as $value) { 
		$value = str_replace($rooturl, '', $value);
		$href = "$siteurl$value";
		$lastmod = gmdate("Y-m-d", (filemtime($root.str_replace('.php','.txt',$value))+($gmt_offset*3600)));

		// write to sitemap.xml
		$xml_data = "<url> 
  <loc>$href</loc>
  <lastmod>$lastmod</lastmod>
  <changefreq>$changefreq</changefreq>
</url>\n";
		$fpx = fopen($xml,'a+');
		fwrite($fpx,$xml_data);
		}
	closedir($dh);
	$endfpx = fopen($xml,'a+');
	fwrite($endfpx,"</urlset>");
	}


function listSnippetsAdmin($root, $basepage_main, $menu_alias) {
	$results = array();
	$handler = opendir($root);
	list($main) = explode('--', $basepage_main); // find main page name
	while ($file = readdir($handler)) {
		if ($file != '.' && $file != '..' && $file != $main.'.txt') {
        		if(preg_match("/^(\b$main\b)/", $file)) { // check for files that start with main page name
            			$results[] = $file;
        			}
    			}
		}
	if (!empty($results)) {
		sort ($results);
		$fullname = str_replace('--', ' &ndash; ', $basepage_main);
		$fullname = str_replace(array('-and-','_and_'), ' & ', $fullname);
		$fullname = ucwords(str_replace(array('-','_'), ' ', strtolower($fullname)));
		list($mainname, $snipbit) = explode(' &ndash; ', $fullname); // find main page name
		$aliasmg = @file_get_contents($menu_alias.$main.'.txt');
		if ( $aliasmg != '' ) {
			$mainname = $aliasmg;
			} else {
			$mainname = $mainname;
			}
		if ( $snipbit == '' ) {
			$alwaysmainname = $mainname;
			} else {
			$alwaysmainname = $mainname.' &ndash; '.$snipbit;
			}
		echo "<div class='last-updated listsnippets'>You are editing \"<b>$alwaysmainname</b>\" &nbsp;|&nbsp; Edit another region?: &nbsp;<select onchange='if(this.value)window.location.href=this.value'>";
		echo "<option value=''> - please select - </option>";
		echo "<option value='$_SERVER[PHP_SELF]?action_edit=edit&editfile=$main.txt'>$mainname</option>";
		foreach ($results as $value) { 
			$filename = substr($value,0,strrpos($value,'.'));
			$fullname = str_replace('--', ' &ndash; ', $filename);
			$fullname = str_replace(array('-and-','_and_'), ' & ', $fullname);
			$fullname = ucwords(str_replace(array('-','_'), ' ', strtolower($fullname)));
			list($mainname, $snipbit) = explode(' &ndash; ', $fullname); // find main page name
			$aliasmg = @file_get_contents($menu_alias.$main.'.txt');
			if ( $aliasmg != '' ) {
				$mainname = $aliasmg;
				} else {
				$mainname = $mainname;
				}
			echo "<option value='$_SERVER[PHP_SELF]?action_edit=edit&editfile=$value'>$mainname &ndash; $snipbit</option>";
			}	
		echo "</select></div>";
		}
	closedir($handler);
	}


function listSnippets($root, $title, $menu_alias, $dynamic_title, $editfile) {
	$results = array();
	$handler = opendir($root);
	list($main) = explode('--', $title); // find main page name
	while ($file = readdir($handler)) {
		if ($file != '.' && $file != '..' && $file != $title.'.txt') {
        		if(preg_match("/^(\b$main\b)/", $file)) { // check for files that start with main page name
            			$results[] = $file;
        			}
    			}
		}
	if (!empty($results)) {
		sort ($results);
		$filename = substr($editfile,0,strrpos($editfile,'.'));
		$fullname = str_replace('--', ' &ndash; ', $filename);
		$fullname = str_replace(array('-and-','_and_'), ' & ', $fullname);
		$fullname = ucwords(str_replace(array('-','_'), ' ', strtolower($fullname)));
		list($mainname, $snipbit) = explode(' &ndash; ', $fullname); // find main page name
		$aliasmg = @file_get_contents($menu_alias.$main.'.txt');
		if ( $aliasmg != '' ) {
			$mainname = $aliasmg;
			} else {
			$mainname = $dynamic_title;
			}
		if ( $snipbit == '' ) {
			$alwaysmainname = $mainname;
			} else {
			$alwaysmainname = $mainname.' &ndash; '.$snipbit;
			}
		echo "<div class='last-updated listsnippets'>You are editing \"<b>$alwaysmainname</b>\" &nbsp;|&nbsp; Edit another region?: &nbsp;<select onchange='if(this.value)window.location.href=this.value'>";
		echo "<option value=''> - please select - </option>";
		echo "<option value='$_SERVER[PHP_SELF]?action_edit=edit&editfile=$title.txt#go_edit'>$mainname</option>";
		foreach ($results as $value) { 
			$filename = substr($value,0,strrpos($value,'.'));
			$fullname = str_replace('--', ' &ndash; ', $filename);
			$fullname = str_replace(array('-and-','_and_'), ' & ', $fullname);
			$fullname = ucwords(str_replace(array('-','_'), ' ', strtolower($fullname)));
			list($mainname, $snipbit) = explode(' &ndash; ', $fullname); // find main page name
			$aliasmg = @file_get_contents($menu_alias.$main.'.txt');
			if ( $aliasmg != '' ) {
				$mainname = $aliasmg;
				} else {
				$mainname = $mainname;
				}
			echo "<option value='$_SERVER[PHP_SELF]?action_edit=edit&editfile=$value#go_edit'>$mainname &ndash; $snipbit</option>";
			}
		echo "</select></div>";
		}
	closedir($handler);
	}


function normalizePath($path) {
	$parts = array();// Array to build a new path from the good parts
	$path = str_replace('\\', '/', $path);// Replace backslashes with forwardslashes
	$path = preg_replace('/\/+/', '/', $path);// Combine multiple slashes into a single slash
	$segments = explode('/', $path);// Collect path segments
	$test = '';// Initialize testing variable
	foreach ($segments as $segment) {
        	if ($segment != '.') {
			$test = array_pop($parts);
			if (is_null($test)) { $parts[] = $segment; }
            		else if($segment == '..') {
				if ($test == '..') { $parts[] = $test; }
				if ($test == '..' || $test == '') { $parts[] = $segment; }
			} else {
				$parts[] = $test;
				$parts[] = $segment;
				}
			}
		}
	return implode('/', $parts);
	}


function fileAllowed($root, $file) {
	$rpath = normalizePath(realpath($root.$file));
	$root = normalizePath($root);
	if (strpos($rpath, $root) === 0) { // Check that $rpath is within allowed directory
		if ( file_exists($root.$file) && strpos($root.$file, '.txt',1) ) {
			return true;
			}
		}
	}

?>