<?php
/*
Fast Edit 1.0 - An "edit in place" tool with extended CMS capabilities (C) 2010 Beverley Hooton
(author website - http://fast-edit.co.uk/)

    Fast Edit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
session_start();
if(isset($use_ob_gzhandler) && ($use_ob_gzhandler == '1')) {
	ob_start('ob_gzhandler'); // use gzip to compress web page - requires zlib extension http://php.net/ob-gzhandler
	} else {
    	ob_start(); // cant use ob_gzhandler and zlib.output_compression together
	}
include_once('fast_edit_config.php');
@require('fast_edit_login.php');
include('fast_edit_functions.php');
include('tinymce/tinymce/jscripts/tiny_mce/plugins/tinybrowser/config_tinybrowser.php');

if($_SESSION['username']) {
	$_SESSION['editfile'] = isset($_GET['editfile']) ? $_GET['editfile'] : '';

	$data = file_get_contents($contentpage);
	if ( (isset($_GET['action'])) && ($_GET['action']=='save') ) {
		$editfile = $_POST['editfile'];
		if ( $editfile == '' ) {
 			header("Location: index.php");
			exit();
			}
		$basepage_edit = substr($editfile, 0, strpos($editfile, '.'));
		$contentpage_edit = $root.$basepage_edit.'.txt';
		$content = $contentpage_edit;
		if ( file_exists($content) ) {
			$data = $_POST['fastedit'];
			$fp = fopen($content,'w');
			$data = stripslashes($data);
// Comment-out the line below to allow PHP to be used via the editor window
			$data = preg_replace(array('/<(\?|\%)\=?(php)?/', '/(\%|\?)>/'), array('',''), $data); // remove old-asp tags, php short-tags, php echo tags, and normal php tags
// Comment-out the line above to allow PHP to be used via the editor window
			fwrite($fp,$data);
			fclose($fp);
			}
		$results = array();
		$handler = opendir($root);
		list($basepage_edit) = explode('--', $basepage_edit); // find main page name
		while (false !== ($file = readdir($handler))) {
			if ($file != '.' && $file != '..' && $file != $basepage_edit.'.txt') {
        			if(preg_match("/^(\b$basepage_edit\b)/", $file)) { // check for files that start with main page name
            				$results[] = $file;
        				}
    				}
			}
		if (!empty($results)) {
			touch($root.$basepage_edit.'.txt');
			foreach ($results as $contentsnippet_time) { 
				touch($root.$contentsnippet_time);
				}
			}
		closedir($handler);
		if (!preg_match('/^[[:space:]]*$/', $_POST['menu_alias'])) {
			$menu_alias_content = $menu_alias.$basepage_edit.'.txt';
			$menu_alias_fp = fopen($menu_alias_content,'w');
			$menu_alias_data = $_POST['menu_alias'];
			$menu_alias_data = htmlentities(stripslashes(trim($menu_alias_data)), ENT_QUOTES, $charset);
			fwrite($menu_alias_fp,$menu_alias_data);
			fclose($menu_alias_fp);
			} else {
			@unlink($menu_alias.$basepage_edit.'.txt');
			}
		if ( $use_metadata_manager == '1') {
			if (!preg_match('/^[[:space:]]*$/', $_POST['meta_keys'])) {
				if ( $basepage_edit == 'index') { 		
					$meta_keys_content = $keywords.'_default_keywords.txt'; 
					} else {
					$meta_keys_content = $keywords.$basepage_edit.'.txt'; 
					}
				$meta_keys_fp = fopen($meta_keys_content,'w');
				$meta_keys_data = $_POST['meta_keys'];
				$meta_keys_data = htmlentities(stripslashes(trim($meta_keys_data)), ENT_QUOTES, $charset);
				fwrite($meta_keys_fp,$meta_keys_data);
				fclose($meta_keys_fp);
				} else {
				@unlink($keywords.$basepage_edit.'.txt');
				}
			if (!preg_match('/^[[:space:]]*$/', $_POST['meta_desc'])) {
				if ( $basepage_edit == 'index') { 		
					$meta_desc_content = $descriptions.'_default_descriptions.txt'; 
					} else {
					$meta_desc_content = $descriptions.$basepage_edit.'.txt'; 
					}
				$meta_desc_fp = fopen($meta_desc_content,'w');
				$meta_desc_data = $_POST['meta_desc'];
				$meta_desc_data = htmlentities(stripslashes(trim($meta_desc_data)), ENT_QUOTES, $charset);
				fwrite($meta_desc_fp,$meta_desc_data);
				fclose($meta_desc_fp);
				} else {
				@unlink($descriptions.$basepage_edit.'.txt');
				}
			}
		header("Location: index.php?action_edit=edit&editfile=$editfile" );
		SiteMap($rooturl, $root, $siteurl, $xml, $changefreq, $page_exclude, $gmt_offset);
		exit();
		}

	if ( (isset($_GET['action'])) && ($_GET['action']=='create') ) {
		if (empty($_POST['file_name'])) { 
    			$no_title_message = "<div class='error'>No title entered for new web page.</div><br/>";
    			echo "<script>window.alert('Sorry, you must first enter a web page title to create a new web page.')</script>"; 
			} else if ( ($_POST['file_name']=='index')||($_POST['file_name']=='Index') ) { 
    			$no_title_message = "<div class='error'>\"Index\" name is in use (it's your home page!). Choose a different name for your new web page.</div><br/>";
    			echo "<script>window.alert('Sorry, you must must use a different name for your new web page.')</script>";
			} else if ( ($_POST['file_name']=='page preview')||($_POST['file_name']=='page_preview')||($_POST['file_name']=='page-preview')||($_POST['file_name']=='Page Preview')||($_POST['file_name']=='Page_Preview')||($_POST['file_name']=='Page-Preview') ) { 
    			$no_title_message = "<div class='error'>\"Page Preview\" name is in use. Choose a different name for your new web page.</div><br/>";
    			echo "<script>window.alert('Sorry, you must must use a different name for your new web page.')</script>"; 
			} else {
			$page_title = $_POST['file_name'];
			$page_url = $_POST['url_name'];
			$base_file_name = str_replace(array('--', ' '), $separator, strtolower( strip_tags( preg_replace('/[^a-zA-Z0-9\s\-\_]/', '', ($_POST['file_name'])) ) ));
			$base_file = $rooturl.$base_file_name.'.php'; 
			$page_protect = array_merge($page_protect, $page_exclude);
			if (!in_array($base_file_name.'.php', $page_protect)) {
				if (!empty($_POST['url_name']) && ($_POST['url_name'] != " e.g.  http://www.website.com ") ) {
					$create_base_file = fopen($base_file, 'w+');
					fwrite($create_base_file, "<?php header('Location: $page_url'); exit();?>");
					fclose($create_base_file);
					header("Location: index.php" );
					} else {
					$create_base_file = fopen($base_file, 'w+');
					fwrite($create_base_file, "<?php include('includes/header.html');?>
						<div class=\"editable\">
							<?php include(\$contentpage);?>
						</div>
					<?php include('includes/footer.html');?>");
					fclose($create_base_file);
					$content_file_name = str_replace(array('--', ' '), $separator, strtolower( strip_tags( preg_replace('/[^a-zA-Z0-9\s\-\_]/', '', ($_POST['file_name'])) ) ));
					$content_file = $root.$content_file_name.'.txt';
					if (!file_exists($content_file)) {
			  			$create_content_file = fopen($content_file, 'w+');
						fwrite($create_content_file, "<h1 class='title'>$page_title</h1><p>This page is currently under construction.</p>");
						fclose($create_content_file);
						} 
					setcookie('.editor', 'open');
					header("Location: index.php?action_edit=edit&editfile=$base_file_name.php" );
					}
				}
			SiteMap($rooturl, $root, $siteurl, $xml, $changefreq, $page_exclude, $gmt_offset);
			exit();
			}
		}

	if ($use_template_manager == '1') {
		$template_data=file_get_contents('editable_site_styles.css');
		if( (isset($_POST['submit_template'])=='Save Template Changes') || ( (isset($_GET['action'])) && ($_GET['action']=='save_template') ) ) {
			$template_content = 'editable_site_styles.css';
			$template_data = $_POST['template'];
			$template_fp = fopen($template_content,'w');
			$template_data = stripslashes($template_data);
			$template_data = preg_replace(array('/<(\?|\%)\=?(php)?/', '/(\%|\?)>/'), array('',''), $template_data);
			fwrite($template_fp,$template_data);
			fclose($template_fp);
			header('Location: index.php');
			exit();
			}

		$template = (isset($_GET['template'])) ? $_GET['template'] : '';
		switch($template) {
				case 'backup_template':
			$backupfile_template = $_GET['backupfile_template'];
			copy('editable_site_styles.css', $rootbackup.'editable_site_styles.css');
			copy('editable_site_styles.css', $rootbackup.'editable_site_styles.txt');
			$url_backup_template = $basepage.'.php';
			break;
				case 'restore_template':
			$restorefile_template = $_GET['restorefile_template'];
			copy($rootbackup.'editable_site_styles.css', 'editable_site_styles.css');
			header('Location: index.php');
			exit();
			break;
				default:
			break;
			}

		}

	$action_edit = (isset($_GET['action_edit'])) ? $_GET['action_edit'] : '';
	$editfile = $_GET['editfile'];
	$basepage_edit = substr($editfile, 0, strpos($editfile, '.'));
	$contentpage_edit = $root.$basepage_edit.'.txt';
	$data = file_get_contents($contentpage_edit);
	list($basepage_main) = @explode('--', $basepage_edit); // get main file instead of snippet
	$alias = @file_get_contents($menu_alias.$basepage_main.'.txt');
	$keys = @file_get_contents($keywords.$basepage_main.'.txt');
	$descs = @file_get_contents($descriptions.$basepage_main.'.txt');
	
	$action = (isset($_GET['action'])) ? $_GET['action'] : '';
	switch($action) {
			case 'delete':
		if ($adv_page_manager == '1') {
			$delfile = $_GET['delfile'];
			$basepage_del = substr($delfile, 0, strpos($delfile, '.'));
			$contentpage_del = $basepage_del.'.txt';
			$page_protect = array_merge($page_protect, $page_exclude);
			if ( (!in_array($delfile, $page_protect)) && $delfile != 'index.php') {
				if ( fileAllowed($root, $contentpage_del) ) {
					@unlink($rooturl.$delfile); 
					@unlink($root.$contentpage_del);
					@unlink($rootbackup.$contentpage_del);
					@unlink($menu_status.$contentpage_del);
					@unlink($menu_alias.$contentpage_del);
					@unlink($keywords.$contentpage_del);
					@unlink($descriptions.$contentpage_del);
					$results = array();
					$handler = opendir($root);
					while (false !== ($file = readdir($handler))) {
						if ($file != '.' && $file != '..') {
        						if(preg_match("/^(\b$basepage_del\b)/", $file)) { // check for files that start with main page name
            							$results[] = $file;
        							}
    							}
						}
					if (!empty($results)) {
						foreach ($results as $contentsnippet_del) { 
							@unlink($root.$contentsnippet_del);
							@unlink($rootbackup.$contentsnippet_del);
							}
						}
					closedir($handler);
					}
				}
			SiteMap($rooturl, $root, $siteurl, $xml, $changefreq, $page_exclude, $gmt_offset);
			header('Location: index.php');
			exit();
			}
		break;
			case 'hide':
		if ($adv_page_manager == '1') {
			$hidefile = $_GET['hidefile'];
			$basepage_hide = substr($hidefile, 0, strpos($hidefile, '.'));
			$contentpage_hide = $basepage_hide.'.txt'; 
			if ( $hidefile != 'index.php' ) { // bev
				$fp = fopen($menu_status.$contentpage_hide, 'w');
				fwrite($fp, "hidden");
				fclose($fp);
				}
			header('Location: index.php');
			exit();
			}
		break;
			case 'unhide':
		if ($adv_page_manager == '1') {
			$unhidefile = $_GET['unhidefile'];
			$basepage_unhide = substr($unhidefile, 0, strpos($unhidefile, '.'));
			$contentpage_unhide = $basepage_unhide.'.txt'; 
			unlink($menu_status.$contentpage_unhide);
			header('Location: index.php');
			exit();
			}
		break;
			case 'order':
		if ($adv_page_manager == '1') {
			$orderfile = $_GET['orderfile'];
			copy($rooturl.$orderfile, $root.$orderfile);
			copy($root.$orderfile, $rooturl.$orderfile);
			unlink($root.$orderfile);
			header('Location: index.php');
			exit();
			}
		break;
			case 'backup':
		$backupfile = $_GET['backupfile'];
		$basepage_backup = substr($backupfile, 0, strpos($backupfile, '.'));
		$contentpage_backup = $basepage_backup.'.txt'; 
		copy($root.$contentpage_backup, $rootbackup.$contentpage_backup);
		$results = array();
		$handler = opendir($root);
		while (false !== ($file = readdir($handler))) {
			if ($file != '.' && $file != '..') {
        			if(preg_match("/^(\b$basepage_backup\b)/", $file)) { // check for files that start with main page name
            				$results[] = $file;
        				}
    				}
			}
		if (!empty($results)) {
			foreach ($results as $contentsnippet_backup) { 
				copy($root.$contentsnippet_backup, $rootbackup.$contentsnippet_backup);
				}
			}
		closedir($handler);
		header('Location: index.php');
		exit();
		break;
			case 'restore':
		$restorefile = $_GET['restorefile'];
		$basepage_restore = substr($restorefile, 0, strpos($restorefile, '.'));
		$contentpage_restore = $basepage_restore.'.txt'; 
		copy($rootbackup.$contentpage_restore, $root.$contentpage_restore);
		$results = array();
		$handler = opendir($root);
		while (false !== ($file = readdir($handler))) {
			if ($file != '.' && $file != '..') {
        			if(preg_match("/^(\b$basepage_restore\b)/", $file)) { // check for files that start with main page name
            				$results[] = $file;
        				}
    				}
			}
		if (!empty($results)) {
			foreach ($results as $contentsnippet_restore) { 
				copy($rootbackup.$contentsnippet_restore, $root.$contentsnippet_restore);
				}
			}
		closedir($handler);
		header('Location: index.php');
		exit();
		break;
			case 'alias':
		if ($adv_page_manager == '1') { 
			$alias_file = $_GET['aliasfile'];
			$title = substr($aliasfile, 0, strpos($aliasfile, '.'));
			$title1 = str_replace(array('-and-','_and-'), ' & ', $title);
			$title2 = str_replace(array('-','_'), ' ', strtolower($title1));
			$dynamic_title = ucwords($title2);
			$aliasfile = file_get_contents($menu_alias.$title.'.txt'); 
			if (!in_array($aliasfile, $page_protect)) {
				$alias_bar = "
					<br/><div class='alias-manager-bg'><span class='alias-manager-bar-single'>
					<form id='page-alias' name='page-alias' method='post' action='".$_SERVER['PHP_SELF']."?action=alias_go'>
					<input type='hidden' id='alias_name' name='alias_name' value='$alias_file' />
					<div class='alias-text'>Menu Alias for \"<b>$dynamic_title</b>\" link button: </div> <div class='alias-textarea-div'><input type='text' class='alias-textarea' name='menu_alias' size='30' value='$aliasfile' />  &nbsp;<span class='alias-span'>(Custom formatted menu button text)</span></div>
					<input type='submit' id='submit_alias_go' name='submit_alias_go' value='' title='Save Alias' class='save' /> &nbsp;|&nbsp; 
					<a href='$basepage.php' title='Cancel'><span class='delete'></span></a>
					</form>
					</span></div>
					";
				}
			}
		break;
			case 'alias_go':
		if ($adv_page_manager == '1') { 
			$aliasname = $_POST['alias_name'];
			$basepage_alias = substr($aliasname, 0, strpos($aliasname, '.'));
			if (!preg_match('/^[[:space:]]*$/', $_POST['menu_alias'])) {
				$menu_alias_data = $_POST['menu_alias'];
				$menu_alias_content = $menu_alias.$basepage_alias.'.txt';
				$menu_alias_fp = fopen($menu_alias_content,'w');
				$menu_alias_data = htmlentities(stripslashes(trim($menu_alias_data)), ENT_QUOTES, $charset);
				fwrite($menu_alias_fp,$menu_alias_data);
				fclose($menu_alias_fp);
				} else {
				$menu_alias_data = $_POST['menu_alias'];
				@unlink($menu_alias.$basepage_alias.'.txt');
				}
			header('Location: index.php');
			exit();
			}
		break;
			default:	
		break;
		}
	}
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8" />
<title>Administration : <?php echo $website_title ;?></title>
<link rel="stylesheet" href="styles/fast_edit.css" />
<!--[if IE]><link rel="stylesheet" href="styles/fast_edit_ie.css" /><![endif]-->
<style>
html { overflow-y:scroll }
body { font:10pt Verdana, Arial, Helvetica, sans-serif; color:#666; padding:25px 0 }
h2 { font:bold 16pt Palatino Linotype, Book Antiqua, Palatino, serif }
h2 a { color:#666; text-decoration:none }
a.link, a.link:visited, a.link:active { color:#f66; text-decoration:none }
h2 a:hover, a.link:hover { color:#69c }
</style>
</head> 
<?php flush();?>
<body>
<h2 style="text-align:center;">Administration : <a href="<?php echo $siteurl?>" target="_blank" title="View <?php echo $website_title?>"><?php echo $website_title?> <span class="web"></span></a></h2>
<div class="fast-edit-outer"><div class="fast-edit-container">

<?php if($_SESSION['username']) { ?>
	<form id="formeditor1" name="formeditor1" method="post" action="<?php echo $_SERVER['PHP_SELF'];?>?action=save">
	Welcome back&nbsp;<?php echo $_SESSION["username"];?>&nbsp;&nbsp;|&nbsp;&nbsp;
	Fast&nbsp;Edit:&nbsp;<span title="Fast Edit" class="edit"></span><span title="Fast Edit" class="close-edit"></span>&nbsp;&nbsp;|&nbsp;&nbsp;
	File&nbsp;Manager:&nbsp;<span title="File Manager" class="file-manager"></span><span title="File Manager" class="close-file-manager"></span>&nbsp;&nbsp;|&nbsp;&nbsp;
	<?php if ($use_template_manager == '1') { echo 'Template Manager:&nbsp;<span title="Template Manager" class="template-manager"></span><span title="Template Manager" class="close-template-manager"></span>&nbsp;&nbsp;|&nbsp;&nbsp;'; } ;?>
	Page&nbsp;Manager:&nbsp;<span title="Page Manager" class="page-manager"></span><span title="Page Manager" class="close-page-manager"></span>&nbsp;&nbsp;|&nbsp;&nbsp;
	Logout&nbsp;<?php echo $_SESSION['username'];?>:&nbsp;<a href="?action=logout"><span title="Logout <?php echo $_SESSION['username'];?>" class="logout"></span></a>
	<a href="" class="close-edit x" title="Close Fast Edit">X</a><br/>
	<?php if (isset($_GET['action_edit'])) {
		$last_modified = filemtime($contentpage_edit);
		echo "<div class='last-updated'>This page was last updated at ".gmdate("h:ia, F jS\, Y", ($last_modified+($gmt_offset*3600)))."</div>";
		echo "<input type='hidden' id='editfile' name='editfile' value='$editfile' />";
		} else {
		echo "<div class='last-updated'>There is no page currently selected</div>";
		}
	?>
		<div class="editor">
			<?php if ( (isset($_GET['action_edit'])) && ($ass_user != '0') && (!in_array($editfile, $ass_pages)) ) { // hide pages not assigned to user ?>
				<div class="error">Sorry, you do not have permission to edit this web page.</div> 
			<?php } else { ?>
			<?php if (isset($_GET['action_edit'])) { 
				listSnippetsAdmin($root, $basepage_edit, $menu_alias); 
				} 
			?>
				<textarea name="fastedit" cols="80" rows="10">
					<?php if (!isset($_GET['action_edit'])) {
						echo "Please select a page to edit from the Page Manager."; 
						} else { 
						echo $data; 
						} 
					?>
				</textarea> 
			<?php } ?>
			<?php if ($adv_page_manager == '1') { 
				if (isset($_GET['action_edit'])) { ?>
				<div class="alias-manager-container">
					<?php if ( $editfile != 'index.php') { ?>
					<div class="alias-manager-bg">
						<span class="alias-manager-bar clear">
						<?php echo "<div class=\"alias-text\">Menu Alias: </div><div class='alias-textarea-div'><input type='text' class='alias-textarea' name='menu_alias' size='30' value='$alias'/> &nbsp;<span class='alias-span'>(Custom formatted menu button text)</span></div>";?>
						</span>
					</div>
					<?php } ?>
					<?php if ( $use_metadata_manager == '1') { ?>
					<div class="alias-manager-bg">
						<span class="meta-manager-bar">
						<?php if ( $editfile == 'index.php' ) { 
							$keys = file_get_contents($keywords.'_default_keywords.txt'); 
							$descs = file_get_contents($descriptions.'_default_descriptions.txt');
							$default = 'Default '; 
							$meta_text_no = '<span class="meta_text_red">Please enter default keywords and description.</a>';
							$meta_text_yes = '<span class="meta_text_green">Default keywords and description are in use.</a>';
							} else {
							$default = 'Custom '; 
							}
						if ( ($keys == '') || ($descs == '') ) {
							$meta_text = '<span class="meta_text_red">Home page defaults will be used if left empty.</a>'; 
							} else {
							$meta_text = '<span class="meta_text_green">Custom keywords and description are in use.</a>'; 
							}
						if ( $keys == '' )
							{
							$meta_border_keys = 'meta_border_red';
							if ( $editfile == 'index.php' ) { 
								$meta_text = $meta_text_no;
								}
							} else {
							$meta_border_keys = 'meta_border_green';
							if ( $editfile == 'index.php' ) { 
								$meta_text = $meta_text_yes;
								}
							}
						if ( $descs == '' ) {
							$meta_border_desc = 'meta_border_red';
							if ( $editfile == 'index.php' ) { 
								$meta_text = $meta_text_no;
								}
							} else {
							$meta_border_desc = 'meta_border_green';
							if ( $editfile == 'index.php' ) { 
								$meta_text = $meta_text_yes;
								}
							}
	
						echo "<div class=\"meta-container clear\">";
						echo "<div class=\"meta-info-outer\">&nbsp; Metadata Manager: <span title='Metadata Manager' class='meta'></span><br/><div class=\"meta-info\">Enter keywords and a description for your web page to help people find it via search engines.<br/><br/>$meta_text</div></div>";
						echo "<div class=\"meta-keys-outer\">&nbsp; $default Keywords: <span style='font-size:8pt;'>(Separate with commas)</span><br/><textarea name='meta_keys' class='$meta_border_keys meta-keys' cols='50' rows='3'>$keys</textarea></div>";
						echo "<div class=\"meta-desc-outer\">&nbsp; $default Description: <br/><textarea name='meta_desc' class='$meta_border_desc meta-desc' cols='50' rows='3'>$descs</textarea></div>";
						echo "</div>";
						?>
						</span>
					</div>
					<?php } ?>
				</div>
			<?php 		} 	
				} 
			?>
		</div>
	</form>

	<div class="file-manager-container">
		<span class="heading">File Manager&nbsp;&nbsp;(manage your website resources)</span>
		<a href="" class="close-file-manager" title="Close File Manager">X</a><br style="clear:both"/>

		<?php if ($tinybrowser['allowupload'] == true) { 
			if ( $quota != '0' ) {
				echo '<div class="quota">';
				$bytestotal = GetFolderSize($rooturl.'userfiles');
				$percent = number_format(($bytestotal/$quota*100), 2, '.', '');
				echo "Space Quota: <b>".ByteSize($quota)."</b> &nbsp;|&nbsp; ";
				echo "Space Used: <b>".ByteSize(GetFolderSize($rooturl.'userfiles'))."</b> (".$percent."%) &nbsp; ";
				echo "<img src='images/graph.php?per=$percent' alt='$percent graph' />";
				echo '&nbsp; | &nbsp;Refresh Values: <a href="'.$_SERVER['REQUEST_URI'].'" title="Refresh Values"><span alt="Refresh Values" class="refresh"></span></a>';
				echo '&nbsp; | &nbsp;Browse All Userfiles: <a href="tinymce/tinymce/jscripts/tiny_mce/plugins/tinybrowser/tinybrowser_filebrowser.php?type=image&folder=&feid=img" title="Browse All Userfiles" target="_blank"><span class="browse"></span></a>';
				if ( $bytestotal >= ($quota/100*95) && $bytestotal <= $quota ) {
					echo '<div class="file-manager-quota-info">You have used <b>'.$percent.'%</b> of your maximum space quota. You can upload <b>'.ByteSize($quota-$bytestotal).'</b> more in resources before the File Manager&#39;s upload function is disabled.</div>';
 					}
				if ( $bytestotal >= $quota ) {
					echo '<div class="file-manager-error">You have reached your maximum space quota of <b>'.ByteSize($quota).'</b>. If you need more space, please consider deleting old or unwanted resources.</div>';
					}
				echo "</div>";
	 			} 
			}
		if ($tinybrowser['allowupload'] == false) { echo "<br/>"; }
		if ( $quota == '0' ) { echo "<br/>"; } 
		?>

		<table>
	  	 <tr>
			<td class="right">Manage&nbsp;Images:</td>
			<td style="padding:0"><a href="" onclick="javascript:tinyBrowserPopUp('image','img'); return false;" title="Manage Images"><span class='images'></span></a></td>
			<td><span class="last-updated">(Upload size limit = <?php echo ByteSize($tinybrowser['maxsize']['image']);?>. Allowed file types = <?php echo $tinybrowser['filetype']['image'];?>)</span></td>
	  	 </tr>
	   	<tr>
			<td class="right">Manage&nbsp;Documents:</td>
			<td style="padding:0"><a href="" onclick="javascript:tinyBrowserPopUp('file','img'); return false;" title="Manage Documents"><span class='docs'></span></a></td>
			<td><span class="last-updated">(Upload size limit = <?php echo ByteSize($tinybrowser['maxsize']['file']);?>. Allowed file types = <?php echo $tinybrowser['filetype']['file'];?>)</span></td>
	  	 </tr>
	  	 <tr>
			<td class="right">Manage&nbsp;Media:</td>
			<td style="padding:0"><a href="" onclick="javascript:tinyBrowserPopUp('media','img'); return false;" title="Manage Media"><span class='media'></span></a></td>
			<td><span class="last-updated">(Upload size limit = <?php echo ByteSize($tinybrowser['maxsize']['media']);?>. Allowed file types = <?php echo $tinybrowser['filetype']['media'];?>)</span></td>
	   	</tr>
		</table>
		
		<div class="file-manager-more">
			<span class="file-manager-more-img" title="More Info"></span> More information
		</div>
		<div class="file-manager-info clear">
			<ul class="left-list">
			<li>While using the File Manager you can perform the following actions;</li>
				<ul>
				<?php if ($tinybrowser['allowupload'] == true) { echo '<li>Upload the file types specified above</li>'; } ;?>
				<?php if ($tinybrowser['allowdelete'] == true) { echo '<li>Delete and move your uploaded files</li>'; } ;?>
				<?php if ($tinybrowser['allowfolders'] == true) { echo '<li>Create, delete and rename folders to order your content</li>'; } ;?>
				</ul>
			</ul>

			<ul class="right-list">
			<li>While using the File Browser you can view and manage your userfiles;</li>
				<ul>
				<li>Browse file/media details, such as size, type, date and path</li>
				<li>Browse images in either a thumbnail-grid or details-list view</li>
				<li>Download individual resources or select all for bulk retrieval</li>
				</ul>
			</ul>
		</div>
	</div>

	<?php if ($use_template_manager == '1') { ?>
	<div class="template-manager-container">
		<div class="template-manager-container-inner">
			<span class="heading">Template Manager&nbsp;&nbsp;(manage your custom CSS styles)</span>
			<a href="" class="close-template-manager" title="Close Template Manager">X</a><br/><br/>
			<form id="template-manager" name="template-manager" method="post" action="<?php echo $_SERVER['PHP_SELF'];?>?action=save_template">
				<div class="template-manager-bg">
					<span class="template-manager-bar">
					Save Changes: <input type="submit" name="submit_template" title="Save Template Changes" class="save-template" value="" /> &nbsp;|&nbsp; 
					Backup: <a href='javascript:confirmBackupTemplate("<?php echo $_SERVER['PHP_SELF'];?>?template=backup_template&backupfile_template")' title='Backup Template'><span class='backup'></span></a> &nbsp;|&nbsp; 
					Preview Backup: <a href='_backup/editable_site_styles.txt' target='_blank' title='Preview Template Backup (new window)'><span class='preview'></span></a> &nbsp;|&nbsp; 
					Restore: <a href='javascript:confirmRestoreTemplate("<?php echo $_SERVER['PHP_SELF'];?>?template=restore_template&restorefile_template")' title='Restore Template Backup'><span class='restore'></span></a>
					</span>
					<div class="templatemanager">
						<textarea name="template" cols="80" rows="10"><?php echo $template_data ?></textarea> 
					</div>
				</div>
			</form>
		</div>
		<div class="template-manager-more">
			<span class="template-manager-more-img" title="More Info"></span>
			Tip: Depending on your browser, if your saved template changes do not immediately show, please do a hard-refresh (CTRL+F5) to reload the updates.
		</div>
	</div>
	<?php } ?>

	<div class="page-manager-container">
		<span class="heading">Page Manager&nbsp;&nbsp;(manage the pages of your website)</span>
		<a href="" class="close-page-manager" title="Close Page Manager">X</a><br style="clear:both"/>

	<?php if ($_GET['action'] != 'alias') { 
		$FolderPath = $root;
		$filecount = filecount($FolderPath);
		$i = 0;
		foreach ($page_exclude as $content_check) {
			$content_check = substr($content_check,0,strrpos($content_check,'.'));
			if (!file_exists($root.$content_check.'.txt')) {
				$i++;
				}
			}

		$results = array();
		$handler = opendir($root);
		while (false !== ($file = readdir($handler))) {
			if ($file != '.' && $file != '..') {
            			$results[] = $file;
    				}
			}
		foreach ($results as $value) { 
        		if(preg_match("/(\b--\b)/", $value)) { // check for files that contain '--'
				$parent_check = substr($value,0,strrpos($value,'.'));
				if (!file_exists($rooturl.$parent_check.'.php')) { // no matching parent page = snippet
					$i--; // remove snippets from page count
					}
				}
			}
		closedir($handler);

		$minus_exc = count($page_exclude);
		$filecount = ($filecount - $minus_exc + $i);
		$pages_left = ($page_count - $filecount);
		if ($adv_page_manager == '1') { 
			if ( ($filecount <= ($page_count - 1)) && ($page_count != 0 ) ) {
				echo '<div class="page-manager-info">You have used <b>'.$filecount.'</b> of <b>'.$page_count.'</b> pages from your maximum web page quota. You can create <b>'.$pages_left.'</b> more page(s) before the New Page creation form below is disabled.</div>';
 				}
			if ( ($filecount <= ($page_count - 1)) || ($page_count == 0 ) ) {
			?>
			<form id="page-creator" name="page-creator" method="post" action="<?php echo $_SERVER['PHP_SELF'];?>?action=create">
				<?php echo $no_title_message;?>
				Title of New Page: <input type="text" name="file_name" size="30" class="create" /> &nbsp;
				Optional URL: <input type="text" id="url" name="url_name" size="30" class="create" value=" e.g.  http://www.website.com " title="Enter a web address to create a menu button that links directly to an external website / file" /> &nbsp;
				Create New Page: <input type="submit" name="submit_create" title="Create" value="" />
				<?php if ($menu_sort == '1') { 
					echo '<span class="last-updated sort">(New pages automatically appear in the menu, sorted alphabetically by page title)</span>';
					} else {
					echo '<span class="last-updated sort">(New pages automatically appear in the menu, arranged manually)</span>';
					} 
				?>
			</form>
			<?php 	
				} 
			if ( $filecount == $page_count ) {
				echo '<div class="page-manager-error">You have reached your maximum web page allowance of <b>'.$page_count.'</b> pages. If you need more pages, please delete old or unwanted ones.</div>';
				}
			if ( $filecount >= $page_count ) {
				if ($page_count != '0') {
					echo '<br/>';
					}
				}
			} 
		if ($adv_page_manager == '0') { echo '<br/>'; }; 
		}

	if ($_GET['action'] == 'alias') { 
		echo $alias_bar;
		} else {
		$dir = opendir($rooturl); 
		while (false !== ($page = readdir($dir))) {
			if (strpos($page, '.php',1)) { 
				if ( ($ass_user != '0') && (!in_array($page, $ass_pages)) ) { // hide pages not assigned to user
					$hidefile = $page; 
					}
				if ( ($page!='..') && ($page!='.') && ($page!=$hidefile) && ($page!='index.php') && ($page!='page_preview.php') && ($page!='_site_admin.php') ) {
					if (!in_array($page, $page_exclude)) {

						$title = substr($page,0,strrpos($page,'.'));
						$title1 = str_replace(array('-and-','_and_'), ' & ', $title);
						$title2 = str_replace(array('-','_'), ' ', strtolower($title1));
						$dynamic_title = ucwords($title2);

						$button_link_check = strpos(file_get_contents($rooturl.$page), '<?php header(\'Location:');

						$aliasfile = file_get_contents($menu_alias.$title.'.txt');
						if ( $aliasfile != '' ) {
							$alias_title = "title=\"Menu Alias = '$aliasfile'\"";
							$alias_indicator = "<span class='indicator'>*</span>";
							} else {
							$alias_title = "title=\"No Menu Alias\"";
							$alias_indicator = "";
							}

						$menu_status_file = $menu_status.$title.'.txt';
						$status = @file_get_contents($menu_status_file);
						if ( $status == 'hidden' ) { 
							$hide_page = "<a href='".$_SERVER['PHP_SELF']."?action=unhide&unhidefile=$page' title='Hidden (click to unhide)'><span class='hidden'>Hidden</span></a>"; 
							} else { 
							$hide_page = "<a href='".$_SERVER['PHP_SELF']."?action=hide&hidefile=$page' title='Visible (click to hide)'><span class='visible'>Visible</span></a>"; 
							}

						if (in_array($page, $page_protect)) {
							$delete_page = "<span title='No Delete (protected)' class='delete-bw'>No Delete</span>";
							} else {
							$delete_page = "<a href='javascript:confirmDelete(\"".$_SERVER['PHP_SELF']."?action=delete&delfile=$page\")' title='Delete Page'><span class='delete'>Delete Page</span></a>";
							}

						if ($button_link_check !== false) {
							$backup_time = $current_time = '';
							$backup_date = $current_date = '&mdash;';
							} else {
							$basepage_backup = substr($page,0,strpos($page, '.'));
							$contentpage_backup = $rootbackup.$basepage_backup.'.txt';
							$backup_time = gmdate("h:ia", (@filemtime($contentpage_backup)+($gmt_offset*3600)));
							$backup_date = gmdate("d-M-y", (@filemtime($contentpage_backup)+($gmt_offset*3600)));
							$contentpage_current = $root.$basepage_backup.'.txt';
							$current_time = gmdate("h:ia", (filemtime($contentpage_current)+($gmt_offset*3600)));
							$current_date = gmdate("d-M-y", (filemtime($contentpage_current)+($gmt_offset*3600)));
							}

						$title_link = 'href="'."$siteurl$page".'"';
						$www = '';
						$target = "target='_blank'";
						$class = 'edit-pm';
						$edit_page = "<a href='$_SERVER[PHP_SELF]?action_edit=edit&editfile=$page' title='Edit Page'><span class='$class'>Edit Page</span></a>";

						if ( file_exists($contentpage_backup) ) {
							if ( filemtime($contentpage_backup) < filemtime($contentpage_current) ) {  
								$bclass = 'backup-old';
								} else {  
								$bclass = 'yes-backup';
								}
							$backup_page = "<a href='javascript:confirmBackup(\"".$_SERVER['PHP_SELF']."?action=backup&backupfile=$page\")' title='Backup Page'><span class='backup'>Backup Page</span></a>";
							$backup_time_status = '<span class="mini">'.filemtime($contentpage_backup).'</span><span class="'.$bclass.'">'.$backup_date.'<br/>'.$backup_time.'</span>';
							$preview_page = "<a href='".$siteurl."page_preview.php?previewfile=$page' target='_blank' title='Preview Backup (new window)'><span class='preview'>Preview Backup</span></a>";
							$restore_page = "<a href='javascript:confirmRestore(\"".$_SERVER['PHP_SELF']."?action=restore&restorefile=$page\")' title='Restore Backup'><span class='restore'>Restore Backup</span></a>";
							} else {
							$backup_page = "<a href='".$_SERVER['PHP_SELF']."?action=backup&backupfile=$page' title='Backup Page'><span class='backup'>Backup Page</span></a>";
							$backup_time_status = '<span class="no-backup">no backup</span>';
							$preview_page = "<span title='No Preview (backup required first)' class='preview-bw'></span>";
							$restore_page = "<span title='No Restore (backup required first)' class='restore-bw'></span>";
							if ($button_link_check !== false) { 
								$backup_page = $backup_time_status = $preview_page = $restore_page = '&mdash;';
								$www = '&nbsp; <span title="External URL (menu button link)" class="ext-link"></span>';
								$url = file_get_contents($rooturl.$page);
								$A = do_reg($url, $regex);
								foreach($A as $B) {
									$ext_url = $B;
									}
								$title_link = 'href="javascript:window.alert(\'NOTICE: This is a menu button link to a website / file.\n\nURL: '."$ext_url".'\')"';
								$target = $class = '';
								if ($adv_page_manager == '1') {
									$edit_page = "<a href='$_SERVER[PHP_SELF]?action=alias&aliasfile=$page' title='Edit Menu Alias'><span class='edit-alias $class'>Edit Menu Alias</span></a>";
									} else {
									$edit_page = '&mdash;';
									}
								}
							}

						if ( $menu_sort == '0' ) {
							$secret_menu_order = "<td class='x'><span class='mini'>".filemtime($rooturl.$page)."</span></td>\n";
							$menu_order = "<td><a href='".$_SERVER['PHP_SELF']."?action=order&orderfile=$page' title='Move To End'><span class='mini'>".filemtime($rooturl.$page)."</span><span class='order'>Move To End</span></a></td>\n";
							}
			
						if ($adv_page_manager == '1') {
							$list .= "<tr>$secret_menu_order<td class='left'><span class='mini'>$dynamic_title</span><a $title_link $alias_title $target>$alias_indicator$dynamic_title$www</a></td><td>$edit_page</td><td><span class='mini'>".filemtime($contentpage_current)."</span>$current_date<br/>$current_time</td>$menu_order<td>$hide_page</td><td>$backup_page</td><td>$backup_time_status</td><td>$preview_page</td><td>$restore_page</td><td>$delete_page</td></tr>";
							} else {
							$list .= "<tr>$secret_menu_order<td class='left'><span class='mini'>$dynamic_title</span><a $title_link $alias_title $target>$alias_indicator$dynamic_title$www</a></td><td>$edit_page</td><td><span class='mini'>".filemtime($contentpage_current)."</span>$current_date<br/>$current_time</td><td>$backup_page</td><td>$backup_time_status</td><td>$preview_page</td><td>$restore_page</td></tr>";
							}
						}
					} 	
				}
			}

		if ( $menu_sort == '0' ) {
			$secret_menu_order = "<th class='left secret'><a title='Click to Sort'></a></th>\n";
			$menu_order_title = "<th><a title='Click to Sort'>Menu Order</a></th>\n";
			}

		if ($adv_page_manager == '1') {
			echo "<div class='pg-center'><table id='page-list-acp' class='tablesorter'><thead><tr>$secret_menu_order<th class='left'><a title='Click to Sort'>Page Title</a></th><th><a title='Click to Sort'>Edit Page</a></th><th><a title='Click to Sort'>Last Update</a></th>$menu_order_title<th><a title='Click to Sort'>Menu Status</a></th><th><a title='Click to Sort'>Backup</a></th><th><a title='Click to Sort'>Last Backup</a></th><th><a title='Click to Sort'>Preview</a></th><th><a title='Click to Sort'>Restore</a></th><th><a title='Click to Sort'>Delete</a></th></tr></thead><tbody>";
			} else {
			echo "<div class='pg-center'><table id='page-list-acp' class='tablesorter'><thead><tr>$secret_menu_order<th class='left'><a title='Click to Sort'>Page Title</a></th><th><a title='Click to Sort'>Edit Page</a></th><th><a title='Click to Sort'>Last Update</a></th><th><a title='Click to Sort'>Backup</a></th><th><a title='Click to Sort'>Last Backup</a></th><th><a title='Click to Sort'>Preview</a></th><th><a title='Click to Sort'>Restore</a></th></tr></thead><tbody>";
			}
// start special functions and hard coding for index.php page
		$contentpage_backup_index = $rootbackup.'index.txt';
		$backup_time_index = gmdate("h:ia", (@filemtime($rootbackup.'index.txt')+($gmt_offset*3600)));
		$backup_date_index = gmdate("d-M-y", (@filemtime($rootbackup.'index.txt')+($gmt_offset*3600)));
		$current_time_index = gmdate("h:ia", (filemtime($root.'index.txt')+($gmt_offset*3600)));
		$current_date_index = gmdate("d-M-y", (filemtime($root.'index.txt')+($gmt_offset*3600)));

		if ( file_exists($rootbackup.'index.txt') ) {
			if ( filemtime($rootbackup.'index.txt') < filemtime($root.'index.txt') ) {  
				$bclass = 'backup-old';
				} else {  
				$bclass = 'yes-backup';
				}
			$backup_index_page = "<a href='javascript:confirmBackup(\"".$_SERVER['PHP_SELF']."?action=backup&backupfile=index.php\")' title='Backup Page'><span class='backup'>Backup Page</span></a>";
			$backup_time_index_status = '<span class="mini">'.filemtime($rootbackup.'index.txt').'</span><span class="'.$bclass.'">'.$backup_date_index.'<br/>'.$backup_time_index.'</span>';
			$preview_index_page = "<a href='".$siteurl."page_preview.php?previewfile=index.php' target='_blank' title='Preview Backup (new window)'><span class='preview'>Preview Backup</span></a>";
			$restore_index_page = "<a href='javascript:confirmRestore(\"".$_SERVER['PHP_SELF']."?action=restore&restorefile=index.php\")' title='Restore Backup'><span class='restore'>Restore Backup</span></a>";
			} else {
			$backup_index_page = "<a href='".$_SERVER['PHP_SELF']."?action=backup&backupfile=index.php' title='Backup Page'><span class='backup'>Backup Page</span></a>";
			$backup_time_index_status = '<span class="no-backup">no backup</span>';
			$preview_index_page = "<span title='No Preview (backup required first)' class='preview-bw'>No Preview</span>";
			$restore_index_page = "<span title='No Restore (backup required first)' class='restore-bw'>No Backup</span>";
			}

		if ( $menu_sort == '0' ) { 
			$secret_menu_order = "<td class='x'><span class='mini'>0</span></td>\n";
			$menu_order_index = "<td><span title='Always First' class='delete-bw'>0Always First</span></td>\n";
			}

		$adv_home = "<tr>$secret_menu_order<td class='left'><span class='mini'>0</span><a href='$siteurl' target='_blank'>Home</a></td><td><a href='".$_SERVER['PHP_SELF']."?action_edit=edit&editfile=index.php' title='Edit Page'><span class='edit-pm'></span></a></td><td><span class='mini'>".filemtime($root.'index.txt')."</span>$current_date_index<br/>$current_time_index</td>$menu_order_index<td><span title='Always Visible' class='visible'></span></td><td>$backup_index_page</td><td>$backup_time_index_status</td><td>$preview_index_page</td><td>$restore_index_page</td><td><span title='No Delete' class='delete-bw'></span></td></tr>";
		$bsc_home = "<tr>$secret_menu_order<td class='left'><span class='mini'>0</span><a href='$siteurl' target='_blank'>Home</a></td><td><a href='".$_SERVER['PHP_SELF']."?action_edit=edit&editfile=index.php' title='Edit Page'><span class='edit-pm'></span></a></td><td><span class='mini'>".filemtime($root.'index.txt')."</span>$current_date_index<br/>$current_time_index</td><td>$backup_index_page</td><td>$backup_time_index_status</td><td>$preview_index_page</td><td>$restore_index_page</td></tr>";
		if ($adv_page_manager == '1') {
			echo $adv_home;
			} else if ( ($adv_page_manager == '0') && ($ass_user == '0') ) {
			echo $bsc_home;
			} else if ( ($adv_page_manager == '0') && ($ass_user != '0') && (in_array('index.php', $ass_pages)) ) { // hide pages not assigned to user
			echo $bsc_home;
			}
// end special functions and hard coding for index.php page

		echo $list;
		echo "</tbody></table>";
		?>
			<br/>
			<div id="pager" class="pager">
				<form>
					<span title="First Page" class="first"></span>
					<span title="Previous Page" class="prev"></span>
					<input type="text" class="pagedisplay"/>
					<span title="Next Page" class="next"></span>
					<span title="Last Page" class="last"></span>
					<select class="pagesize">
						<?php foreach ($pager_increments as $pager_inc) { 
							if ($pager_inc == $pager_default_limit ) {
								echo "<option value=\"$pager_inc\">$pager_inc per page *</option>";
								} else {
								echo "<option value=\"$pager_inc\">$pager_inc per page</option>";
								}
							}
						?>	
						<option value="1000">All pages</option>	
					</select> <span class="last-updated">(* default limit is <?php echo $pager_default_limit;?> per page)</span>
				</form>
				<div class="pm-downloads">
					<form action="download.php" method="POST">
						Download All Pages: <input type="submit" title="Zip and Download" value="" class="zip"/>
					</form>
				</div>
			</div>
		</div>
	<?php } ?>
	</div>
<?php } else { ?>
	<p style="text-align:center">Sorry, you do not have permission to access this area. Please login.</p>
	<?php if (isset($login_error)) { echo $login_error; } ?>
	<br/>
	<div style="text-align:center; margin-bottom:25px">
		Admin Login: <span class="login"></span>
		<div class="login-box" style="display:block; margin:5px auto auto">
			<form method="post" action="<?php echo $_SERVER['PHP_SELF'];?>?action=login">
			Username:<br/><input type="text" name="name" size="15" style="margin:2px auto"/><br/>
			Password:<br/><input type="password" name="pass" size="15" style="margin:2px auto"/><br/>
			<input type="image" src="images/login.gif" name="submit_login" alt="Login" title="Login" class="login-submit"/>
			</form>
		</div>
	</div>
<?php } ?>
</div></div>
<div class="last-updated" style="text-align:center">
	<p>Copyright &copy; 2010-<?php echo date('Y')?> Beverley Hooton &mdash; <a href="http://fast-edit.co.uk/" target="_blank" title="Visit the Fast Edit website" class="link">Fast Edit</a></p>
</div>
<?php if($_SESSION['username']) { ?>
<script src="http://code.jquery.com/jquery-latest.min.js"></script>
<script src="js/jquery.cookie.js"></script> 
<script src="tinymce/tinymce/jscripts/tiny_mce/tiny_mce.js"></script>
<script src="tinymce/tinymce/jscripts/tiny_mce/plugins/tinybrowser/tb_tinymce.js.php"></script>
<script src="tinymce/tinymce/jscripts/tiny_mce/plugins/tinybrowser/tb_standalone.js.php"></script>
<script src="js/fast_edit_toolbar.js"></script> 
<script src="js/jquery.tablesorter.js"></script> 
<script src="js/jquery.tablesorter.widgets.js"></script>
<script src="js/jquery.tablesorter.pager.js"></script>
<script src="js/fast_edit_functions.js"></script>
<script>
jQuery(document).ready(function() {
	jQuery('.edit-pm').click( function () { jQuery.cookie('.editor', 'open'); } );
});
<?php if ( $menu_sort == '0' && $adv_page_manager == '1' ); { ?> 
	jQuery("#page-list-acp").tablesorter( {sortList:[[4,0]], saveSort:true} ).tablesorterPager( {container:jQuery(".pager"), savePages:true, output:'{page} / {totalPages}'} ) // menu order, ascending 
<?php } if ( $menu_sort == '0' && $adv_page_manager == '0' ) { ?>
	jQuery("#page-list-acp").tablesorter( {sortList:[[0,0], [2,0]], saveSort:true} ).tablesorterPager( {container:jQuery(".pager"), savePages:true, output:'{page} / {totalPages}'} ) // title, last updated, ascending
<?php } if ( $menu_sort == '1' ) { ?>
	jQuery("#page-list-acp").tablesorter( {sortList:[[0,0]], saveSort:true} ).tablesorterPager( {container:jQuery(".pager"), savePages:true, output:'{page} / {totalPages}'} ) // title, ascending
<?php } 
} ?>
</script>
</body>
</html>